; +------------------------------------------+
; | Algoritme FFT. Adaptacio per A. J. Anton |
; +------------------------------------------+
;  19/8/94 (requereix 387 o millor)
; primera optimitzacio

; declaracions:
; int FFT(complex x[], unsigned n);
; struct { float re, im; } complex;

        .387
        PUBLIC _FFT             ; fa public el nom de la funcio
        
_local  SEGMENT PARA 'DATA'

b       dd ?
e       dd ?
cos     dd ?
sin     dd ?
temp_r  dd ?
temp_i  dd ?

base    dw ?
pot     dw ?
N       dw ?
a       dw ?
cte2    dw 2
c       dw ?
f       dw ?
d       dw ?
u       dw ?
g       dw ?
h       dw ?
j       dw ?
p       dw ?
s       dw ?

_local  ENDS

_text   SEGMENT PARA PUBLIC 'CODE'
        ASSUME cs:_text, ds:_local

_FFT    PROC FAR
        push bp
        mov bp,sp               ; estableix l'enlla
        push si
        push di                 ; guarda regs. index
        push ds
        push es                 ; guarda segments
        
        mov ax,_local
        mov ds,ax               ; actualitzda DS
        
        mov ax,[bp + 8]         ; segment on es troba el vector de complexos
        mov es,ax
        mov ax,[bp + 6]         ; offset al vector
        mov [base],ax
        mov ax,[bp + 10]        ; potencia de 2
        mov [pot],ax
        
        mov cl,al
        mov ax,1
        rol ax,cl               ; N = 2**n
        mov [N],ax

        mov [a], ax             ; a = N

        finit                   ; inicialitza el 387
        fldpi                   ; carrega pi
        fild cte2
        fmul                    ; multiplica per 2
        fild N                  ; carrea N
        fdiv                    ; divideix per N
        fstp b                  ; guarda en (float) b = 2 * pi / N
        fwait

        mov word ptr [c],1      ; for(c = 1; c <= n(==pot); c++)
for1:   mov ax,[c]
        cmp ax,[pot]
        jle cont1
        jmp endf1

cont1:  mov ax,[a]
        mov [d],ax              ; d = a

        sar ax,1
        mov [a],ax              ; a = a / 2

        fldz
        fstp e                  ; e = (float) 0.0
        fwait

        mov word ptr [f],1      ; for(f = 1; f <= a; f++)
for2:   mov ax,[f]
        cmp ax,[a]
        jle cont2
        jmp endf2

cont2:  fld e
        fsincos                 ; calcula el coseno i seno de e
        fstp cos                ; cos = cos(e)
        fstp sin                ; sin = sin(e)
        
        fld e
        fadd b
        fstp e                  ; e = e + b
        fwait
        
        mov word ptr [u],1      ; u = 1
        
        mov ax,[d]              ; for(g = d; g <= N; g = u * d)
        mov [g],ax
for3:   mov ax,[g]
        cmp ax,[N]
        jle cont3
        jmp endf3

cont3:  inc [u]                 ; u++

        mov ax,[g]
        add ax,[f]
        sub ax,[d]
        mov [h],ax              ; h = g - d + f

        add ax,[a]
        mov [j],ax              ; j = h + a

        mov si,[h]
        rol si,1
        rol si,1
        rol si,1
        add si,[base]           ; si = base + h * 8 (tamany del vector)
        mov di,[j]
        rol di,1
        rol di,1
        rol di,1
        add di,[base]           ; di = base + j * 8 (tamany del vector)

        fld dword ptr es:[si]                   ; carrega x[h].x
        fsub dword ptr es:[di]                  ; resta x[j].x
        fstp dword ptr temp_r                   ; temp_r = x[h].x - x[j].x
        fld dword ptr es:[si + 4]               ; carrega x[h].y
        fsub dword ptr es:[di + 4]              ; resta x[j].y
        fstp dword ptr temp_i                   ; temp_i = x[h].y - x[j].y
        
        fld dword ptr es:[si]                   ; carrega x[h].x
        fadd dword ptr es:[di]                  ; suma x[j].x
        fstp dword ptr es:[si]                  ; x[h].x = x[h].x + x[j].x
        fld dword ptr es:[si + 4]               ; carrega x[h].y
        fadd dword ptr es:[di + 4]              ; suma x[j].y
        fstp dword ptr es:[si + 4]              ; x[h].y = x[h].y + x[j].y

        fld cos
        fmul temp_r                             ; co * t.x
        fld sin
        fmul temp_i                             ; si * t.y
        fadd                                    ; (co * t.x) + (si * t.y)
        fstp dword ptr es:[di]                  ; x[j].x = co * t.x + si * t.y

        fld cos
        fmul temp_i                             ; co * t.y
        fld sin
        fmul temp_r                             ; si * t.x
        fsub                                    ; (co * t.y) - (si * t.x)
        fstp dword ptr es:[di + 4]              ; x[j].y = co * t.y - si * t.x
        fwait

loopf3: mov ax,[u]
        mul [d]
        mov [g],ax              ; g = u * d
        jmp for3
endf3:

loopf2: inc [f]                 ; f++
        jmp for2
endf2:

        fld b                   ; carrega b
        fild cte2               ; carrega (int) 2
        fmul
        fstp b                  ; b = b * 2 (float)
        fwait
        
loopf1: inc [c]                 ; c++
        jmp for1
endf1:

        mov cx,1                ; m = 1         (optz. r=bx, m=cx, q=dx)
        mov ax,[N]
        sar ax, 1
        mov [p], ax             ; p = N / 2
        mov dx,[N]
        sub dx,1                ; q = N - 1
        
        mov bx, 1               ; for(r = 1; r <= q; r++)
for4:   cmp bx,dx
        jle cont4
        jmp endf4

cont4:  mov ax,cx
        dec ax
        cmp ax,bx
        jl label1               ; if(m - 1 < r) goto label1

        mov si,bx
        rol si,1
        rol si,1
        rol si,1
        add si,[base]           ; si = base + r * 8 (tamany vector)
        mov di,cx
        rol di,1
        rol di,1
        rol di,1
        add di,[base]           ; di = base + m * 8 (tamany vector)

        push cx
        mov cx,4                ; repeteix 4 vegades XCHG (tamany vector / 2)
lla:   mov ax,word ptr es:[si]
        xchg ax,word ptr es:[di]
        mov word ptr es:[si], ax
        add si,2
        add di,2
        loop lla               ; swap x[r], x[m]
        pop cx
        
label1: mov ax,[p]
        mov [s],ax              ; s = p

label3: mov ax,cx
        dec ax
        cmp ax,[s]
        jl label2               ; if(m - 1 < s) goto label2
        sub cx,[s]              ; m = m - s
        mov ax,[s]
        sar ax,1
        mov [s],ax              ; s = s / 2
        jmp label3              ; goto label3

label2: add cx,[s]              ; m = m + s
        inc bx                  ; r++
        jmp for4
endf4:

        mov ax,[N]              ; retorna N (numero de punts)

        pop es
        pop ds
        pop di
        pop si                  ; recupera registres
        mov sp,bp
        pop bp                  ; trenca l'enlla
        
        retf
        
_FFT    ENDP

_text   ENDS

        END
